# Patrick van der Wel, 2012 March

# macro that creates intermediate peak from 1-3 selected peaks, and then deletes the original peaks
# does not do too much common sense checking yet
# TODOs/ideas:
#  - check distance between peaks (presumably do not want to do this to distant peaks)
#  - check for existing assignments - possibly combine them? Perhaps via merge peaks command or something?
#      or possibly via propagate assignments prior to deletion?

#following instructions from web
# see http://sites.google.com/site/ccpnwiki/Home/documentation/ccpnmr-analysis/howtos-1/write-a-macro
# also note Wayne's comments about the peak deletion code (April 5)

from ccpnmr.analysis.core.PeakBasic import makeIntermediatePeak
from ccpnmr.analysis.core.PeakBasic import deletePeak
from ccpnmr.analysis.core.WindowBasic import deleteSelected
from ccpnmr.analysis.core.AssignmentBasic import propagatePeakAssignments

def intermediatepeakMacro(argServer):
  peaks = argServer.getCurrentPeaks()
  oldpeaks = peaks[:]
  if peaks:
     if len(peaks) <4 :
       newpk = makeIntermediatePeak(oldpeaks)
       allpeaks =  oldpeaks[:]
       allpeaks.append(newpk)
       propagatePeakAssignments(allpeaks)
       deletePeak(oldpeaks)

     else :
        print "too many peaks selected!"

